#ifndef CIVPGCONN_H
#define CIVPGCONN_H
#include <libpq-fe.h>

#include "CivDbConn.h"

/**
 postgress ݿ
*/
class DBEXPORT CivPgConn: public CivDbConn
{
public:
	CivPgConn(char* uri);
	~CivPgConn();

	/**
	*@brief ݿ⣬йʵ
	*/
	virtual bool open();

	/**
	*@brief رݿӣйʵ
	*/
	virtual void close();

	/**
	*@brief жĳűǷڣжϷݿйأӳٵʵ
	*@tableName: 
	*/
	virtual bool tableExist(StrQuote tableName);

	/**
	*@brief ִsql
	*@sql: Ҫִеsql
	*/
	virtual bool execSql(StrQuote sql);
	virtual bool getNode(CivNode& node) ;
	virtual bool getPipe(CivPipe& pipe) ;
	virtual bool getTank(CivTank& tank) ;
	virtual bool getValve(CivValve& valve) ;
	virtual bool getPumps(CivPumps& pump) ;
	virtual bool getReservoirs(CivReservoirs& reservoirs) ;
	virtual bool getEmitters(CivEmitters& emitter) ;
	virtual bool getCoordinates(CivCoordinates& coord) ;
	virtual bool getMixing(CivMixing& mixing) ;
	virtual bool getParameter(std::vector<CivParameter>& param) ;
	virtual bool getPatterns(CivPatterns& patterns) ;
	virtual bool getCurves(CivCurves& curves) ;
	virtual bool getDemands(CivDemands& demands) ;
	virtual bool getSources(CivSources& sources) ;
	virtual bool getStatus(CivStatus& status) ;
	virtual bool getQuality(CivQuality& quality) ;
	virtual bool getLabels(CivLabels& labels) ;
	virtual bool getTags(CivTags& tags) ;

private:
	PGconn* mConn; // Ӷ
	PGresult* mResult;  // ѯ

	char* mUri;
};

#endif // !CIVPGCONN_H
