#pragma once
#include "CivSimulResultCache.h"

class CivDbConn;

/**
ˮģ
*/
class CivHydrSimulation
{
public:
	explicit CivHydrSimulation();
	explicit CivHydrSimulation(CivDbConn* dbConn);
	~CivHydrSimulation();

	/**
	 *@biref עݿ
	 */
	void registDb(CivDbConn* dbConn);

	/**
	*@brief ˮģ
	*/
	int hdyrSimulation();

	/**
	*@brief ˮģ⣬ˮ䣬ѧ
	*/
	int qualitySimulation();

	/**
	*@brief ׷ٷȻʽˮʷ
	*@snNode׷ٵĽڵ
	*/
	int trackingSimulation(char* snNode);

	/**
	*@inpļ
	*/
	bool convertInp();

	inline char*  getInpFile();
	inline void setInpFile(const std::string& inpFile);

	inline char* getRptFile();
	inline void setRptFile(const std::string& rptFile);

	inline char* getBinFile();
	inline void setBinFile(const std::string& binFile);

private:
	void getNodeResult(short time);
	void getLinkResult(short time);
    void getNodeQuality(short time);
    void getLinkQuality(short time);

private:
	CivDbConn* mDbConn;
	CivSimulResultCache mResultCache; // 洢ģ
	std::string mInpFile;// inpļ
	std::string mRptFile; // ļ
	std::string mBinFile;// ļ
};
